<?php

namespace App\Http\Controllers\Auth;

use App\Http\Controllers\Controller;
use App\Models\User;
use App\Providers\RouteServiceProvider;
use Illuminate\Auth\Events\Registered;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules;
use Illuminate\View\View;
use App\Models\Azienda;

class RegisteredUserController extends Controller
{
    /**
     * Display the registration view.
     */
    public function create(): View
    {
        $aziende = Azienda::all();
        return view('auth.register', compact('aziende'));
    }

    /**
     * Genera un codice personale a partire dal cognome.
     */
    private function generaCodicePersonale($cognome)
    {
        // Prendi solo le consonanti (ignora maiuscole/minuscole)
        $consonanti = preg_replace('/[aeiouAEIOU\s]/', '', $cognome);

        // Se le consonanti sono meno di 10, aggiungi numeri casuali
        $codice = strtoupper($consonanti); // metti tutto maiuscolo
        $numeriCasuali = '';

        while (strlen($codice . $numeriCasuali) < 10) {
            $numeriCasuali .= rand(0, 9);
        }

        // Prendi solo i primi 10 caratteri
        return substr($codice . $numeriCasuali, 0, 10);
    }


    /**
     * Handle an incoming registration request.
     *
     * @throws \Illuminate\Validation\ValidationException
     */
    public function store(Request $request): RedirectResponse
    {

        // Genera codice personale
        $codicePersonale = $this->generaCodicePersonale($request->surname);
        //dd($codicePersonale);

        $user = User::create([
            'name' => $request->name,
            'surname' => $request->surname,
            'PIVA' => $request->piva,
            'email' => $request->email,
            'password' => bcrypt($request->password),
            'role' => 'user',
            'AZND' => $request->AZND,
            'azienda_id' => $request->azienda_id,
            'codice_personale' => $codicePersonale,
            'codice_fiscale' => $request->codice_fiscale,
            'telefono' => $request->telefono,
        ]);

        event(new Registered($user));

        Auth::login($user);

        return redirect(RouteServiceProvider::HOME);
    }
}
